=== libraries/Cabal/Cabal/doc/requirements.txt ===
sphinx == 3.1.*
sphinx_rtd_theme
