## ghc 9.4.6

=== debian/changelog ===
ghc (9.4.6-1) unstable; urgency=medium

  * Upload to unstable (Closes: #1017663, #1039474)

 -- Ilias Tsitsimpis <iliastsi@debian.org>  Fri, 25 Aug 2023 20:12:47 +0300

ghc (9.4.6-1~exp4) experimental; urgency=medium

  * Fallback to LLVM 15
  * Do not depend on LLVM for arm64, it now has a native codegen

 -- Ilias Tsitsimpis <iliastsi@debian.org>  Sun, 20 Aug 2023 23:13:59 +0300

ghc (9.4.6-1~exp3) experimental; urgency=medium

  * Backport upstream patch to use old pass manager in LLVM

 -- Ilias Tsitsimpis <iliastsi@debian.org>  Sun, 20 Aug 2023 15:33:14 +0300

ghc (9.4.6-1~exp2) experimental; urgency=medium

  * Use LLVM 16

 -- Ilias Tsitsimpis <iliastsi@debian.org>  Sun, 20 Aug 2023 10:33:37 +0300

ghc (9.4.6-1~exp1) experimental; urgency=medium

  * New upstream release
  * Do not reduce parallelism on mipsel, as this doesn't fix OOM issues
  * Drop 'ghc-prim-libatomic' patch, doesn't work
  * Do not run inplace/bin/ghc-stage2 for cross-builds (Closes: #1042078)

 -- Ilias Tsitsimpis <iliastsi@debian.org>  Fri, 11 Aug 2023 19:52:02 +0300

ghc (9.4.5-1~exp3) experimental; urgency=medium

  * Try to reduce parallel builds on mipsel

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 01 Aug 2023 09:23:09 +0200

ghc (9.4.5-1~exp2) experimental; urgency=medium

  * Re-introduce 'fix-llvm-armel' patch
  * Drop 'Disable-unboxed-arrays' patch, not needed any more
  * Build unregisterised on riscv64
  * Use libatomic in ghc-prim library

 -- Ilias Tsitsimpis <iliastsi@debian.org>  Fri, 07 Jul 2023 19:12:19 +0300

ghc (9.4.5-1~exp1) experimental; urgency=medium

  [ Gianfranco Costamagna ]
  * Don't use llvm on riscv64, doesn't fix the build

  [ Ilias Tsitsimpis ]
  * New upstream release

 -- Ilias Tsitsimpis <iliastsi@debian.org>  Sun, 02 Jul 2023 18:10:44 +0300

ghc (9.2.7-1~exp3) experimental; urgency=medium

  * debian/patches/5fe11fe612e1881bd4d1b9d5950d0d801e08e159.patch:
    - cherry-pick upstream patch to increase llvm upper bound to 15

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 20 Apr 2023 12:26:28 +0200

ghc (9.2.7-1~exp2) experimental; urgency=medium

  * Switch to llvm-14 and add riscv64 to llvm-* archs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 20 Apr 2023 09:51:25 +0200

ghc (9.2.7-1~exp1) experimental; urgency=medium

  * New upstream release.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 16 Mar 2023 19:21:44 +0100

ghc (9.2.5-1~exp2) experimental; urgency=medium

  * build-fix-hs-constants.patch
    - cherry-pick upstream proposed fix for build failure.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 29 Nov 2022 14:35:58 +0100

ghc (9.2.5-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Drop patches now part of upstream codebase:
    - buildpath-abi-stability-2.patch
    - latomic-subword
    - latomic-64bit
  * Refresh patches

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 29 Nov 2022 10:29:14 +0100
