=== debian/control ===
--- 
+++ 
@@ -13,9 +13,9 @@
   devscripts,
   grep-dctrl,
   pkg-config,
-  ghc:native (>= 8.6),
+  ghc:native (>= 9.0),
   libgmp-dev,
-  llvm-13 [arm64 armel armhf],
+  llvm-15 [armel armhf],
   libffi-dev,
   libncurses-dev,
   python3-sphinx <!cross>,
@@ -32,7 +32,7 @@
 Package: ghc
 Architecture: any
 Depends:
-  llvm-13 [arm64 armel armhf],
+  llvm-15 [armel armhf],
   gcc,
   libgmp-dev,
   libffi-dev,
@@ -55,7 +55,7 @@
 Conflicts: ghc6 (<< 7), ghc-dynamic (<< 7.8)
 Breaks: cabal-install (<< 1.22), haskell-devscripts (<< 0.8.13),
  ghc-doc (<< 7.10), ghc-haddock (<< 7.10), ${conflicting-devs}
-Suggests: perl, ghc-prof, ghc-doc, haskell-doc, llvm-13
+Suggests: perl, ghc-prof, ghc-doc, haskell-doc, llvm-15
 Description: The Glasgow Haskell Compilation system
  The Glorious Glasgow Haskell Compilation system (GHC) is a compiler for
  Haskell.
