=== debian/rules ===
--- 
+++ 
@@ -39,20 +39,13 @@
 
 DEB_HOOGLE_TXT_DIR = /usr/lib/ghc-doc/hoogle/
 
-ifneq (,$(filter i386 powerpcspe x32 s390x, $(DEB_HOST_ARCH)))
+ifneq (,$(filter i386 powerpcspe x32 s390x riscv64, $(DEB_HOST_ARCH)))
   # From GHC 8.10 and later, native code generator support for legacy x87
   # floating point coprocessor has been removed. GHC now only support floating
   # point via SSE2. This causes a baseline violation on Debian for i386 where
   # there is no SSE support. Fallback to unregisterised builds on i386.
   EXTRA_CONFIGURE_FLAGS += --enable-unregisterised
 endif
-
-#ifeq (yes,$(shell dpkg-vendor --derives-from Ubuntu && echo yes))
-#ifeq (armhf,$(DEB_HOST_ARCH))
-#  # armhf on Ubuntu needs unregisterised due to performance issues during build.
-#  EXTRA_CONFIGURE_FLAGS += --enable-unregisterised
-#endif
-#endif
 
 # Use system's default ld (ld.bfd) rather than ld.gold, which fails for
 # haskell-cryptohash-sha256 on mips/mipsel. For more information, see
@@ -69,7 +62,7 @@
 	dh $@
 
 override_dh_autoreconf:
-	dh_autoreconf perl -- boot
+	dh_autoreconf ./boot.source
 
 override_dh_auto_configure:
 	echo "SRC_HC_OPTS += -lffi -optl-pthread" >> mk/build.mk
@@ -93,10 +86,6 @@
 endif
 ifeq (armhf,$(DEB_HOST_ARCH))
 	echo "SRC_HC_OPTS += -D__ARM_PCS_VFP" >> mk/build.mk
-endif
-ifeq (big, $(DEB_TARGET_ARCH_ENDIAN))
-	# See https://gitlab.haskell.org/ghc/ghc/issues/16998
-	patch -p1 < debian/patches/Disable-unboxed-arrays.patch
 endif
 ifneq (,$(filter powerpcspe x32 s390x, $(DEB_HOST_ARCH)))
 	# From Fedora
@@ -138,6 +127,13 @@
 	# We also want to build the threaded profiling-enabled debug runtime,
 	# because it does no harm
 	echo 'GhcRTSWays += $$(if $$(filter p, $$(GhcLibWays)),thr_debug_p,)' >> mk/build.mk
+
+	# The make build system is completely broken at this point, since it
+	# doesn't pass the '-build-tool-depends' flag (as Handrian does) and require
+	# alex/happy to build from a release tarball.
+	echo 'utils/genprimopcode_CONFIGURE_OPTS += "-f-build-tool-depends"' >> mk/build.mk
+	echo 'compiler_CONFIGURE_OPTS += "-f-build-tool-depends"' >> mk/build.mk
+	echo 'utils/hpc_CONFIGURE_OPTS += "-f-build-tool-depends"' >> mk/build.mk
 
 	# We can't do this with a configure flag in 6.8.1 as libdir is not
 	# defined at the point at which we := it
